
	local LBF = LibStub("LibButtonFacade", true)
	local L = LibStub("AceLocale-3.0"):GetLocale("Watcher")
	local AceAddon = LibStub("AceAddon-3.0")
	local media = LibStub:GetLibrary("LibSharedMedia-3.0");
	Watcher = AceAddon:NewAddon("Watcher", "AceConsole-3.0", "AceEvent-3.0", "AceTimer-3.0")
	local SCT = SCT
	local REVISION = tonumber(("$Revision: 46 $"):match("%d+"))
	local _, _, _, clientVersion = GetBuildInfo()
	Watcher.constants = {}
	local C = Watcher.constants -- Defined in Watcher LUA no locale needed.
	local called = 0
	Watcher.combat = false
	local pvpinstance = false
	Watcher.isBoss = true
	Watcher.fonts = {}
	Watcher.dir = {}
	Watcher.dir["right"] = "right"
	Watcher.dir["left"] = "left"
	Watcher.dir["up"] = "up"
	Watcher.dir["down"] = "down"
	Watcher.swing = nil
	Watcher.PriorityFrame = CreateFrame("Frame", "Watcher_PriorityFrame", UIParent)
	Watcher.PriorityFrame.axisbase = CreateFrame("Frame", "Watcher_PriorityFrameAB", Watcher.PriorityFrame)
	Watcher.Priority1 = CreateFrame("Button", "Watcher_PriorityFrame1", Watcher.PriorityFrame)
	Watcher.Priority2 = CreateFrame("Button", "Watcher_PriorityFrame2", Watcher.PriorityFrame)
	Watcher.Priority3 = CreateFrame("Button", "Watcher_PriorityFrame3", Watcher.PriorityFrame)
	Watcher.Priority4 = CreateFrame("Button", "Watcher_PriorityFrame4", Watcher.PriorityFrame)
	Watcher.Priority5 = CreateFrame("Button", "Watcher_PriorityFrame5", Watcher.PriorityFrame)
	Watcher.Priority6 = CreateFrame("Button", "Watcher_PriorityFrame6", Watcher.PriorityFrame)
	Watcher.Priority7 = CreateFrame("Button", "Watcher_PriorityFrame7", Watcher.PriorityFrame)
	Watcher.Priority8 = CreateFrame("Button", "Watcher_PriorityFrame8", Watcher.PriorityFrame)
	Watcher.PriorityS = CreateFrame("Frame", "Watcher_PriorityFrameSwing", Watcher.PriorityFrame)
	Watcher.PriorityGCD = CreateFrame("Frame", "Watcher_PriorityFrameGCD", Watcher.PriorityFrame)
	Watcher.swingtype = 0
	Watcher.usedspells = 0
	Watcher.offset = 0
	Watcher.timeLeft = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0 , 0 ,0, 0, 0, 0, 0, 0, 0, 0,0}
	Watcher.targetex = false
	Watcher.textpoint = {}
	Watcher.textpoint["top"] = "top"
	Watcher.textpoint["bottom"] = "bottom"
	Watcher.textpoint["center"] = "center"
	Watcher.priorityTable = {}
	Watcher.priorityTable.name = {}
	Watcher.priorityTable.icon = {}
	Watcher.priorityTable.check = {}
	Watcher.textures = {}
	Watcher.fonts = {}

	Watcher.defaults = {

		char = {
			enable = true,
			message = "Welcome Home!",
			barshow = false,
			showtarget = false,
			showraid = false,
			showparty = false,
			enablepvp = false,
			alpha = 1,
			balpha = 0.6,
			showcombat = false,
			showicons = true,
			relativeTo = "UIParent",
			relativePoint = "CENTER",
			point = "CENTER",
			iconfont = "Friz Quadrata TT",
			bartexture = "Flat",
			iconfontsize = 12,
			iconfonteffect = "none",
			xOffset = 0,
			yOffset = -100,
			resetOn = true,
			scale = 1,
			showgcd = true,
			showswing = true,
			showbars = false,
			textpoint =  "top",
			showaxis = true,
			growdir = "right",
			disablebars = false,
			debug = false,
			stackmoving = true,  
			hideprimary = false,
			hidesecondary = false,
			barcol = {
			bar1 = {r = 1, g = 0, b = 0, a = 1},
			bar2 = {r = 0, g = 1, b = 0, a = 1},
			bar3 = {r = 0, g = 0, b = 1, a = 1},
			bar4 = {r = 1, g = 1, b = 0, a = 1},
			bar5 = {r = 1, g = 0, b = 1, a = 1},
			bar6 = {r = 0, g = 1, b = 1, a = 1},
			bar7 = {r = 1, g = 0.5, b = 0, a = 1},
			bar8 = {r = 1, g = 0, b = 0.5, a = 1},
			},
			baralpha = 0.7,
			--barcol[a] = 1,
			spell = {
				check = {},
				spellname = {},
				name = {},
				typedot = {},
				typeshortdot = {},
				dotlength = {},
				dottime = {},
				isbuff = {},
				icon = {},
				powerthresh = {},
				countreq = {},
				dotthreshold = {},
				combocost = {},
				trackspell = {},
				nocd = {},
				caster = {},
				isproc = {},
				},
			warrior = {
				sunderarmor = 1.5,
				hsragethresh = 0,
				},
			druid = {
				srcombo = 1,
				ripcombo = 5,
				fbcombo = 3,
				},
			hunter = {
				dh = 95,
				v = 5,
			},
			priority = {
				show = true,
				textshow = true,
				relativeTo = "UIParent",
				relativePoint = "CENTER",
				point = "CENTER",
				fWidth = 50,
				fHeight = 50,
				skin = "Blizzard",
				backdrop = 0,
				gloss = 0,
				IconSize = 50,
				alpha = 0.4,
				scale = 1,	
				Label = {"", "", "", "", "", "", "", ""},
				label = {"", "", "", "", "", "", "", ""},
				label2 = {"", "", "", "", "", "", "", ""},
				showlabel = true,
				onlyboss = {false, false, false, false, false, false, false, false, false},
				onlyboss1 = { false, false, false, false, false, false, false, false, false},
				onlyboss2 = { false, false, false, false, false, false, false, false, false},
				option2 = { "gcd", "none", "none", "none", "none", "none", "none", "none", "none"},
				option1 = { "gcd", "none", "none", "none", "none", "none", "none", "none", "none"},
				option = { "gcd", "none", "none", "none", "none", "none", "none", "none", "none"},
				keybindings = {},
				keybindings1 = { nil, nil, nil, nil, nil, nil, nil, nil},
				keybindings2 = { nil, nil, nil, nil, nil, nil, nil, nil},
				isDot = {},
				isBuff = {},
				maxtime = 10,
				labelvert = 0,
				keyvert = 0,
				labelhori = 0,
				keyhori = 0,
				interval = 1.5,
				
				labelcol = {r = 1,g = 1,b = 1,a = 1},
				keycol = {r = 1,g = 1,b = 1,a = 1},
			},
		},
	}

	--Watcher.Priority2.texture = Watcher.Priority2:CreateTexture(nil, "BACKGROUND")
	
		
	Watcher.priorityTable.name["none"] = L["None"]
	_, _, Watcher.priorityTable.icon["none"] = "Interface/Tooltips/UI-Tooltip-Background"
			Watcher.priorityTable.check["none"] = function (FrameName, optionnum)
		
			
			end 


	-------------
	--Set Up / Event Functions
	-------------
	function Watcher:OnInitialize()
		local AceConfigReg = LibStub("AceConfigRegistry-3.0")
		local AceConfigDialog = LibStub("AceConfigDialog-3.0")
		self.db = LibStub("AceDB-3.0"):New("WatcherDBPC", Watcher.defaults, "char")
		self.db:RegisterDefaults(self.defaults)
		
		media.RegisterCallback(self, "LibSharedMedia_Registered")
		Watcher:SetOptions()
		Watcher:SwitchTalents()
		Watcher:AddCustomSpells()
		if LBF then
		LBF:RegisterSkinCallback("Watcher", self.SkinChanged, self)	
		end
		local version = GetAddOnMetadata("Watcher","Version")
		self.version = ("Watcher v%s (r%s)"):format(version, REVISION)
		self:Print(self.version.." Loaded.")
		if LBF then
		local group = LBF:Group("Watcher","Watcher1")
		group:Skin(self.db.char.priority.skin, self.db.char.priority.gloss, self.db.char.priority.backdrop)
		end
	end

	Watcher.SkinChanged = function(arg, SkinID, Gloss, Backdrop, Group, Button, Colors)
	Watcher.db.char.priority.skin = SkinID
	Watcher.db.char.priority.gloss = Gloss
	Watcher.db.char.priority.backdrop = Backdrop
	Watcher:CreatePriorityFrame()
	end
	
	function Watcher:hidespec()
	local groupIndex = GetActiveTalentGroup()
	--self:Print(self.db.char.hideprimary)
	if groupIndex == 1 and self.db.char.hideprimary then
	--	self:Print("true")
	self.PriorityFrame:Hide()
		return true
	elseif groupIndex == 2 and self.db.char.hidesecondary then
	self.PriorityFrame:Hide()
		return true
	end
	self.PriorityFrame:Show()
	return false
	end
	
	function Watcher:AddCustomSpells()
		 for i = 1, table.getn(self.db.char.spell.name) do
			if self.db.char.spell.name[i] ~= nil and self.db.char.spell.name[i] ~= "SKIP" then
				--self:Print(self.db.char.spell.name[i])
				self.priorityTable.name[self.db.char.spell.name[i]] = self.db.char.spell.name[i]
				self.priorityTable.icon[self.db.char.spell.name[i]] = self.db.char.spell.icon[i]
				self.priorityTable.check[self.db.char.spell.name[i]] = function (FrameName, optionnum)
					Watcher:UpdateSpell(FrameName, optionnum, self.db.char.spell.typedot[i], Watcher:BuffInfo(i, self.db.char.spell.trackspell[i]), self.db.char.spell.typeshortdot[i], self.db.char.spell.dottime[i],0, self.db.char.spell.spellname[i].."()", self.db.char.spell.powerthresh[i], self.db.char.spell.countreq[i], self.db.char.spell.dotthreshold[i], self.db.char.spell.combocost[i], self.db.char.spell.isproc[i], Watcher:CountInfo(i, self.db.char.spell.trackspell[i]))	
				end
			end
		end
	end
	
	function Watcher:CountInfo(i, trackspell)
		local index = 1
		if self.db.char.spell.isbuff[i] then
		while UnitBuff("PLAYER", index) do
		local name, _, _, count, _, _, buffexpires = UnitBuff("PLAYER", index)
		if name == trackspell then
			--self:Print(self.db.char.spell.nocd[i])
			if self.db.char.spell.nocd[i] then
			return true
			else
			--self:Print(count)
			--if count == nil then count = 0 end
			return count
			end
		end
		index = index + 1
		end
		else
		while UnitDebuff("TARGET", index) do
		local name, _, _, count, _, dur, buffexpires, caster = UnitDebuff("TARGET", index)
		if name == trackspell and Watcher:Caster(i, caster) then
			--self:Print(count)
			if count == nil then count = 0 end
			return count
		end
		index = index + 1
		end
	end
	return 0, 0 
	end
	
	function Watcher:BuffInfo(i, trackspell)
		local index = 1
		if self.db.char.spell.isbuff[i] then
		while UnitBuff("PLAYER", index) do
		local name, _, _, count, _, _, buffexpires = UnitBuff("PLAYER", index)
		if name == trackspell then
			--self:Print(self.db.char.spell.nocd[i])
			if self.db.char.spell.nocd[i] then
			return true
			else
			--if count == nil then count = 0 end
			return buffexpires - GetTime(), count
			end
		end
		index = index + 1
		end
		else
		while UnitDebuff("TARGET", index) do
		local name, _, _, count, _, dur, buffexpires, caster = UnitDebuff("TARGET", index)
		if name == trackspell and Watcher:Caster(i, caster) then
			--self:Print(count)
			if count == nil then count = 0 end
			return buffexpires - GetTime(), count
		end
		index = index + 1
		end
	end
	return 0, 0 
	end
	
	function Watcher:Caster(i, caster)
		if self.db.char.spell.caster[i] and caster == "player" then
			return true
		elseif not self.db.char.spell.caster[i] then
			return true
		else 
			return false
		end
	end
	
	function Watcher:OnEnable()
		self:LibSharedMedia_Registered()
		Watcher:SwitchTalents()
		self:RegisterEvent("PLAYER_ENTERING_WORLD")
		self:RegisterEvent("PLAYER_REGEN_DISABLED")
		self:RegisterEvent("PLAYER_REGEN_ENABLED")
		self:RegisterEvent("PLAYER_TALENT_UPDATE")
		self:RegisterEvent("RAID_ROSTER_UPDATE")
		self:RegisterEvent("PARTY_MEMBERS_CHANGED")
		self:RegisterEvent("UNIT_ENTERED_VEHICLE")
		self:RegisterEvent("UNIT_EXITED_VEHICLE")
		self:RegisterEvent("UNIT_SPELLCAST_SUCCEEDED")
		self:RegisterEvent("PLAYER_TARGET_CHANGED")
		self:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")

	end


	function Watcher:COMBAT_LOG_EVENT_UNFILTERED()
	if arg3 == UnitGUID("player") and arg6 == UnitGUID("playertarget")  then
		if arg2 == "SWING_DAMAGE" or arg2 == "SWING_MISS" then
				Watcher.swingtype = 0
				Watcher.swing = GetTime()
		elseif arg2 == "RANGE_DAMAGE" or arg2 == "RANGE_MISS" then
				Watcher.swingtype = 1
				Watcher.swing = GetTime()
		end
		end
	end
		
	function Watcher:PLAYER_ENTERING_WORLD()
		local ininstance, instance = IsInInstance()
		if (instance == "pvp" or instance == "arena") then
		pvpinstance = true
		self:CreatePriorityFrame()
		else
		pvpinstance = false
		self:CreatePriorityFrame()
		end
	end

	function Watcher:PLAYER_REGEN_DISABLED()
		if Watcher:scan() then
			Watcher.isBoss = true
		else
			Watcher.isBoss = false
		end
		Watcher.combat = true
		self:CreatePriorityFrame()
	end

	function Watcher:PLAYER_REGEN_ENABLED()
		Watcher.combat = false
		self:CreatePriorityFrame()
	end

	function Watcher:DisplayVersion()
		self:Print(self.version)
	end

	function Watcher:PLAYER_TALENT_UPDATE()
		self:SwitchTalents()	
		self:CreatePriorityFrame()
	end

	function Watcher:PLAYER_TARGET_CHANGED()	
		local pretarget = Watcher.isBoss
		if UnitExists("target") then	
			Watcher.targetex = true
		else
			Watcher.targetex = false
		end
		if Watcher:scan() then
			Watcher.isBoss = true
			--self:Print(Watcher.isBoss)
		else
			Watcher.isBoss = false
			--self:Print(Watcher.isBoss)
		end
		if pretarget ~= Watcher.isBoss then
		self:CreatePriorityFrame()
		end
	end


	function Watcher:UNIT_SPELLCAST_SUCCEEDED()
	if arg1 == "player" then
		for i= 1, table.getn(self.db.char.spell.name) do
			if self.db.char.spell.typeshortdot[i] then
				if arg2 == self.db.char.spell.trackspell[i] then
					self.db.char.spell.dottime[i] = self.db.char.spell.dotlength[i] + GetTime()
				end
			end
		end
	end
	end

	function Watcher:LibSharedMedia_Registered()
		for k, v in pairs(media:List("font")) do
			self.fonts[v] = v
		end
		for k, v in pairs(media:List("statusbar")) do
			self.textures[v] = v
		end
	end

	function Watcher:scan()
		if Watcher:checkTarget("target") then return true end
		if Watcher:checkTarget("focus") then return true end
		if UnitInRaid("player") then
			for i = 1, GetNumRaidMembers() do
				if Watcher:checkTarget("raid"..i.."target") then return true end
			end
		else
			for i = 1, 5 do
				if Watcher:checkTarget("party"..i.."target") then return true end
			end
		end
		return false
	end

	function Watcher:checkTarget(id)
		return UnitExists(id) and UnitClassification(id) == "worldboss"
	end

	function Watcher:SwitchTalents()	
		local groupIndex = GetActiveTalentGroup()
			if groupIndex == 1 then 
				self.db.char.priority.option = self.db.char.priority.option1
				self.db.char.priority.onlyboss = self.db.char.priority.onlyboss1
				self.db.char.priority.Label = self.db.char.priority.label
				self.db.char.priority.keybindings = self.db.char.priority.keybindings1
			elseif groupIndex == 2 then 
				self.db.char.priority.option = self.db.char.priority.option2
				self.db.char.priority.onlyboss = self.db.char.priority.onlyboss2
				self.db.char.priority.Label = self.db.char.priority.label2
				self.db.char.priority.keybindings = self.db.char.priority.keybindings2
		end
		
	end

	function Watcher:UNIT_ENTERED_VEHICLE()
		self:CreatePriorityFrame()
	end

	function Watcher:UNIT_EXITED_VEHICLE()
		self:CreatePriorityFrame()
	end

	function Watcher:CheckRaidParty()
		local raidnum = GetNumRaidMembers()
		local partynum = GetNumPartyMembers()
		if partynum > 0 and self.db.char.showparty == true then
			self.PriorityFrame:Show()
		elseif raidnum >= 1 and self.db.char.showraid == true then
			self.PriorityFrame:Show()
		else
			self.PriorityFrame:Hide()
		end
	end

	function Watcher:RAID_ROSTER_UPDATE()
		self:CreatePriorityFrame()
	end

	function Watcher:PARTY_MEMBERS_CHANGED()
		self:CreatePriorityFrame()
	end

	function Watcher:bossmob(optionnum)
		if self.db.char.priority.onlyboss[optionnum] and Watcher.isBoss then
			return true
		elseif not self.db.char.priority.onlyboss[optionnum] then
			return true
		else
			return false
		end
	end


	-------------------------------
	-- Priority functions
	-------------------------------

	function Watcher:MoveIcon(FrameName, timeleft, optionnum)
		local Offset = 0
		FrameName:SetFrameLevel(180- ((optionnum-1)*10))
		if self.db.char.stackmoving or timeleft == 0 and optionnum > 1 then
			for i = 2, optionnum - 1 do
				if optionnum > 2 then
					if Watcher.timeLeft[i] >= 0 then
						if ((timeleft) - Watcher.timeLeft[i]) >= -1.5 and ((timeleft) - Watcher.timeLeft[i]) <=1.50 then
							Offset = Offset + 1
						end
					end
				end
			end
		end
		if self.db.char.showbars then
			local movingprio = 0
			local movingnum = 0
			for i=2, 18 do
				if Watcher.timeLeft[i] > 1.5 then movingnum = movingnum + 1 end
			end
			for i=optionnum, 18 do
				if Watcher.timeLeft[i] > 1.5 then movingprio = movingprio + 1 end
			end
			if timeleft <= 1.5 then
				FrameName.statusbar:SetAlpha(0)
			else
				FrameName.statusbar:SetAlpha(self.db.char.baralpha)
			end
			local offset
			if timeleft <= self.db.char.priority.maxtime then
				offset = timeleft
			else
				offset = self.db.char.priority.maxtime
			end
			FrameName.statusbar:ClearAllPoints()	
			if self.db.char.growdir == "left" or self.db.char.growdir == "right" then
				FrameName.statusbar:SetWidth(offset*Watcher.db.char.priority.IconSize/1.5)
				FrameName.statusbar:SetHeight(Watcher.db.char.priority.IconSize/movingnum)
				FrameName.statusbar:SetPoint("BOTTOMLEFT", self.PriorityFrame, "BOTTOMLEFT", self.db.char.priority.IconSize, self.db.char.priority.IconSize*(movingnum-movingprio)/movingnum)
			else
				FrameName.statusbar:SetWidth(Watcher.db.char.priority.IconSize/movingnum - 1)
				FrameName.statusbar:SetHeight(offset*Watcher.db.char.priority.IconSize/1.5)
				FrameName.statusbar:SetPoint("BOTTOMLEFT", self.PriorityFrame, "BOTTOMLEFT", -self.db.char.priority.IconSize*(movingnum-movingprio)/movingnum, self.db.char.priority.IconSize)
			end
		end			
		if self.db.char.growdir == "up" then 
			FrameName:SetPoint("BOTTOMRIGHT", Watcher.PriorityFrame, "BOTTOMRIGHT",  -(Watcher.db.char.priority.IconSize * 0.2) * (Offset) , (timeleft * Watcher.db.char.priority.fWidth / 1.5))
		elseif self.db.char.growdir == "down" then 
			FrameName:SetPoint("TOPLEFT", Watcher.PriorityFrame, "TOPLEFT",  -(Watcher.db.char.priority.IconSize * 0.2) * (Offset) , -(timeleft * Watcher.db.char.priority.fWidth / 1.5))
		elseif self.db.char.growdir == "right" then 
			FrameName:SetPoint("BOTTOMLEFT", Watcher.PriorityFrame, "BOTTOMLEFT",  (timeleft * Watcher.db.char.priority.fWidth / 1.5) , (Watcher.db.char.priority.IconSize * 0.2) * (Offset))
		elseif self.db.char.growdir == "left" then 
			FrameName:SetPoint("BOTTOMRIGHT", Watcher.PriorityFrame, "BOTTOMRIGHT",  -(timeleft * Watcher.db.char.priority.fWidth / 1.5), (Watcher.db.char.priority.IconSize * 0.2) * (Offset))
		end
	end

	function Watcher:DurationString(duration)
		local string = (("%1.1f"):format(duration % 120));
		
		if (duration >= 120) then
			duration = floor(duration - (duration % 60)) / 60; -- minutes
			
			string = ((duration % 60) + 1) .."m " --.. string;
			
			if (duration >= 120) then
				duration = (duration - (duration % 60)) / 60; -- hours
				string = (duration + 1).. "h " --.. string;
			end
		end
		return string
	end
	--------------------------
	--- Layout Functions
	--------------------------
	function Watcher:CreatePriorityFrame()
		--[[called = called + 1
		self:Print(called)
		]]
		if not self.db.char.enable or self:hidespec() then
			return
		end
		self.PriorityFrame:ClearAllPoints()
		self.PriorityFrame:SetScale(self.db.char.scale)
		self.PriorityFrame:SetFrameStrata("BACKGROUND")
		self.PriorityFrame:SetAlpha(self.db.char.alpha)
		if self.db.char.growdir == "right" then
		self.PriorityFrame:SetWidth(self.db.char.priority.IconSize + ((Watcher.db.char.priority.fWidth * self.db.char.priority.maxtime)/ 1.5))
		self.PriorityFrame:SetHeight(self.db.char.priority.IconSize)
		elseif self.db.char.growdir == "down" then
		self.PriorityFrame:SetHeight(self.db.char.priority.IconSize + ((Watcher.db.char.priority.fWidth * self.db.char.priority.maxtime)/ 1.5))
		self.PriorityFrame:SetWidth(self.db.char.priority.IconSize)
		elseif self.db.char.growdir == "left" then
		self.PriorityFrame:SetWidth(self.db.char.priority.IconSize + ((Watcher.db.char.priority.fWidth * self.db.char.priority.maxtime)/ 1.5))
		self.PriorityFrame:SetHeight(self.db.char.priority.IconSize)
		elseif self.db.char.growdir == "up" then
		self.PriorityFrame:SetHeight(self.db.char.priority.IconSize + ((Watcher.db.char.priority.fWidth * self.db.char.priority.maxtime)/ 1.5))
		self.PriorityFrame:SetWidth(self.db.char.priority.IconSize)
		end
		self.PriorityFrame:SetBackdrop({
			bgFile = "Interface/Tooltips/UI-Tooltip-Background",
			--edgeFile = "Interface/Tooltips/UI-Tooltip-Border",
			tile = false, tileSize = 0, edgeSize = 0,
			insets = { left = 0, right = 0, top = 0, bottom = 0 }
		})
		self.PriorityFrame:SetBackdropColor(0, 0, 0, self.db.char.balpha);
		self.PriorityFrame:SetMovable(true);
		self.PriorityFrame:RegisterForDrag("LeftButton");
		self.PriorityFrame:SetPoint(self.db.char.point, self.db.char.relativeTo, self.db.char.relativePoint, self.db.char.xOffset, self.db.char.yOffset)
		self.PriorityFrame:SetScript("OnDragStart", 
			function()
				self.PriorityFrame:StartMoving();
			end );
		self.PriorityFrame:SetScript("OnDragStop",
			function()
				self.PriorityFrame:StopMovingOrSizing();
				self.PriorityFrame:SetScript("OnUpdate", nil);
				self:FinishedMoving(self.db.char, self.PriorityFrame);
			end );
		if self.db.char.showgcd then
		Watcher:SetPriorityFrame(self.PriorityGCD,1)
		self.PriorityGCD:Show()
		else
		self.PriorityGCD:Hide()
		end
		if self.db.char.showswing then
		Watcher:SwingTimer(self.PriorityS)
		self.PriorityS:Show()
		else
		self.PriorityS:Hide()
		end
		Watcher:SetPriorityFrame(self.Priority1,2)
		Watcher:SetPriorityFrame(self.Priority2,3)
		Watcher:SetPriorityFrame(self.Priority3,4)
		Watcher:SetPriorityFrame(self.Priority4,5)
		Watcher:SetPriorityFrame(self.Priority5,6)
		Watcher:SetPriorityFrame(self.Priority6,7)
		Watcher:SetPriorityFrame(self.Priority7,8)
		Watcher:SetPriorityFrame(self.Priority8,9)
		self:Axis()
		if self.db.char.showcombat == true then
			if self.combat == true then
				self.PriorityFrame:Show()
			else
				self.PriorityFrame:Hide()
			end
		else 
			self.PriorityFrame:Show()
		end
		if self.db.char.showtarget and not Watcher.targetex then
			self.PriorityFrame:Hide()
		end
		if pvpinstance == true and not self.db.char.enablepvp then
			self.PriorityFrame:Hide()
		end
		if UnitInVehicle("player") then
			self.PriorityFrame:Hide()
		end
		if self.db.char.showraid == true or self.db.char.showparty == true then
			self:CheckRaidParty()
		
		end
		
	end
		
	function Watcher:AxisText()
			if not self.PriorityFrame.axisbase.textmin then
			self.PriorityFrame.axisbase.textmin = Watcher.PriorityFrame.axisbase:CreateFontString(nil, "OVERLAY")
			end
			self.PriorityFrame.axisbase.textmin:SetFont(media:Fetch("font", self.db.char.iconfont),12, self.db.char.iconfonteffect)
			self.PriorityFrame.axisbase.textmin:ClearAllPoints()
			if self.db.char.growdir == "right" then
			self.PriorityFrame.axisbase.textmin:SetPoint("TOP", self.PriorityFrame, "BOTTOMLEFT" , Watcher.db.char.priority.IconSize, -(8))
			elseif self.db.char.growdir == "left" then
			self.PriorityFrame.axisbase.textmin:SetPoint("TOP", self.PriorityFrame, "BOTTOMRIGHT" , -Watcher.db.char.priority.IconSize, -(8))
			elseif self.db.char.growdir == "up" then
			self.PriorityFrame.axisbase.textmin:SetPoint("LEFT", self.PriorityFrame, "BOTTOMRIGHT" ,( 8), Watcher.db.char.priority.IconSize)
			elseif self.db.char.growdir == "down" then
			self.PriorityFrame.axisbase.textmin:SetPoint("LEFT", self.PriorityFrame, "TOPRIGHT" ,( 8), -Watcher.db.char.priority.IconSize)
			end
			self.PriorityFrame.axisbase.textmin:SetText(0)
			local maxtime = self.db.char.priority.maxtime
			local interval = self.db.char.priority.interval
			if not self.PriorityFrame.axisbase.text then
			self.PriorityFrame.axisbase.text = {}
			end
			for i = 1, (maxtime / interval) do
			--self.PriorityFrame.axisbase.text[i] = nil
			if not self.PriorityFrame.axisbase.text[i] then
			--self:Print(i)
			self.PriorityFrame.axisbase.text[i] = Watcher.PriorityFrame.axisbase:CreateFontString(nil, "OVERLAY")
			end
			--self.PriorityFrame.axisbase.text[i] = SetFont(media:Fetch("font", self.db.char.iconfont), 12, self.db.char.iconfonteffect)
			self.PriorityFrame.axisbase.text[i]:SetFont(media:Fetch("font", self.db.char.iconfont), 12, self.db.char.iconfonteffect)
			self.PriorityFrame.axisbase.text[i]:ClearAllPoints()
			if self.db.char.growdir == "right" then
			self.PriorityFrame.axisbase.text[i]:SetPoint("TOP", self.PriorityFrame, "BOTTOMLEFT" , Watcher.db.char.priority.IconSize +(Watcher.db.char.priority.fWidth * self.db.char.priority.interval * i / 1.5), -(8))
			elseif self.db.char.growdir == "left" then
			self.PriorityFrame.axisbase.text[i]:SetPoint("TOP", self.PriorityFrame, "BOTTOMRIGHT" , -Watcher.db.char.priority.IconSize -(Watcher.db.char.priority.fWidth * self.db.char.priority.interval * i / 1.5), -(8))
			elseif self.db.char.growdir == "up" then
			self.PriorityFrame.axisbase.text[i]:SetPoint("LEFT", self.PriorityFrame, "BOTTOMRIGHT" ,(8), Watcher.db.char.priority.IconSize +(Watcher.db.char.priority.fWidth * self.db.char.priority.interval * i / 1.5))
			elseif self.db.char.growdir == "down" then
			self.PriorityFrame.axisbase.text[i]:SetPoint("LEFT", self.PriorityFrame, "TOPRIGHT" ,(8), -Watcher.db.char.priority.IconSize -(Watcher.db.char.priority.fWidth * self.db.char.priority.interval * i / 1.5))
			end
			self.PriorityFrame.axisbase.text[i]:SetText(i * interval)
			end
		end	

		
	function Watcher:SwingTimer(FrameName)
		FrameName:ClearAllPoints()
		FrameName:SetFrameStrata("BACKGROUND")
		FrameName:SetWidth(Watcher.db.char.priority.IconSize)
		FrameName:SetHeight(self.db.char.priority.IconSize)
		FrameName:EnableMouse(0)

		if self.db.char.growdir == "right" then
			FrameName:SetPoint("BOTTOMLEFT", self.PriorityFrame, "BOTTOMLEFT", 0, 0)
			elseif self.db.char.growdir == "up"  then
			FrameName:SetPoint("BOTTOMRIGHT", self.PriorityFrame, "BOTTOMRIGHT", 0, 0)
			elseif self.db.char.growdir == "left" then
			FrameName:SetPoint("BOTTOMRIGHT", self.PriorityFrame, "BOTTOMRIGHT", 0, 0)	
			elseif self.db.char.growdir == "down" then
			FrameName:SetPoint("TOPRIGHT", self.PriorityFrame, "TOPRIGHT", 0, 0)
			end
		if not FrameName.swingtexture then
				FrameName.swingtexture = FrameName:CreateTexture(nil, "OVERLAY")
		end
		FrameName.swingtexture:ClearAllPoints()
		FrameName.swingtexture:SetWidth(self.db.char.priority.fHeight / 10)
		FrameName.swingtexture:SetHeight(self.db.char.priority.fHeight / 10)
		if self.db.char.growdir == "right" then
		FrameName.swingtexture:SetPoint("TOPLEFT", FrameName, "BOTTOMRIGHT", 0, 0)
		elseif self.db.char.growdir == "up"  then
		FrameName.swingtexture:SetPoint("BOTTOMLEFT", FrameName, "TOPRIGHT", 0, 0)
		elseif self.db.char.growdir == "left" then
		FrameName.swingtexture:SetPoint("TOPRIGHT", FrameName, "BOTTOMLEFT", 0, 0)	
		elseif self.db.char.growdir == "down" then
		FrameName.swingtexture:SetPoint("TOPLEFT", FrameName, "BOTTOMRIGHT", 0, 0)
		end
		FrameName.swingtexture:SetTexture(1,0,0,1)
		FrameName.swingtexture:SetAlpha(0)
		
		FrameName:SetScript("OnUpdate", 
			function()
					if Watcher.swing ~= nil then
					local AttackSpeed
					if Watcher.swingtype == 1 then
					AttackSpeed, _ = UnitRangedDamage("player")
					else
					AttackSpeed, _ = UnitAttackSpeed("player")
					end
					local time_since_swing = GetTime() - Watcher.swing
					if time_since_swing <= AttackSpeed then
					FrameName.swingtexture:SetAlpha(1)
					if self.db.char.growdir == "right" then
						FrameName.swingtexture:SetPoint("TOPLEFT", FrameName, "BOTTOMRIGHT",((AttackSpeed - time_since_swing) * Watcher.db.char.priority.fWidth / 1.5), 0)
					elseif self.db.char.growdir == "up"  then
						FrameName.swingtexture:SetPoint("BOTTOMLEFT", FrameName, "TOPRIGHT", 0, ((AttackSpeed - time_since_swing) * Watcher.db.char.priority.fWidth / 1.5))
					elseif self.db.char.growdir == "left" then
						FrameName.swingtexture:SetPoint("TOPRIGHT", FrameName, "BOTTOMLEFT", ((AttackSpeed - time_since_swing) * -Watcher.db.char.priority.fWidth / 1.5), 0)	
					elseif self.db.char.growdir == "down" then
						FrameName.swingtexture:SetPoint("TOPLEFT", FrameName, "BOTTOMRIGHT", 0, -((AttackSpeed - time_since_swing) * Watcher.db.char.priority.fWidth / 1.5))
					end
					else
					FrameName.swingtexture:SetAlpha(0)
					end
					end
			end	);		
	end	
		
	function Watcher:Axis()
		self.PriorityFrame.axisbase:ClearAllPoints()
		if not self.PriorityFrame.axis then
			self.PriorityFrame.axis = self.PriorityFrame.axisbase:CreateTexture(nil, "OVERLAY")
		end
		self.PriorityFrame.axisbase:ClearAllPoints()
		self.PriorityFrame.axis:ClearAllPoints()
		if self.db.char.growdir == "right" then
		self.PriorityFrame.axis:SetWidth(Watcher.db.char.priority.fWidth * (self.db.char.priority.maxtime) / 1.5)
		self.PriorityFrame.axis:SetHeight(self.db.char.priority.fHeight / 10)
		self.PriorityFrame.axis:SetPoint("TOPLEFT", self.PriorityFrame, "BOTTOMLEFT", Watcher.db.char.priority.IconSize, 0)
		elseif self.db.char.growdir == "left" then
		self.PriorityFrame.axis:SetWidth(Watcher.db.char.priority.fWidth * self.db.char.priority.maxtime / 1.5)
		self.PriorityFrame.axis:SetHeight(self.db.char.priority.fHeight / 10)
		self.PriorityFrame.axis:SetPoint("TOPRIGHT", self.PriorityFrame, "BOTTOMRIGHT", -Watcher.db.char.priority.IconSize, 0)
		elseif self.db.char.growdir == "down" then
		self.PriorityFrame.axis:SetHeight(Watcher.db.char.priority.fWidth * self.db.char.priority.maxtime / 1.5)
		self.PriorityFrame.axis:SetWidth(self.db.char.priority.fHeight / 10)
		self.PriorityFrame.axis:SetPoint("TOPLEFT", self.PriorityFrame, "TOPRIGHT", 0, -Watcher.db.char.priority.IconSize)
		elseif self.db.char.growdir == "up" then
		self.PriorityFrame.axis:SetHeight(Watcher.db.char.priority.fWidth * self.db.char.priority.maxtime / 1.5)
		self.PriorityFrame.axis:SetWidth(self.db.char.priority.fHeight / 10)
		self.PriorityFrame.axis:SetPoint("TOPLEFT", self.PriorityFrame, "TOPRIGHT", 0,0)
		end
		self.PriorityFrame.axis:SetTexture(1, 1, 1, 1)
		self.PriorityFrame.axis:Show()
		if not self.PriorityFrame.axisgcd then -- "Finish Line"
			self.PriorityFrame.axisgcd = self.PriorityFrame.axisbase:CreateTexture(nil, "OVERLAY")
		end
		--self.PriorityFrame.axisgcd:SetFrameLevel(10)
		self.PriorityFrame.axisgcd:ClearAllPoints()
		if self.db.char.growdir == "right" then
		self.PriorityFrame.axisgcd:SetHeight(Watcher.db.char.priority.IconSize)
		self.PriorityFrame.axisgcd:SetWidth(self.db.char.priority.fHeight / 10)
		self.PriorityFrame.axisgcd:SetPoint("BOTTOMLEFT", self.PriorityFrame, "BOTTOMLEFT",Watcher.db.char.priority.IconSize, 0)
		end
		if self.db.char.growdir == "left" then
		self.PriorityFrame.axisgcd:SetHeight(Watcher.db.char.priority.IconSize)
		self.PriorityFrame.axisgcd:SetWidth(self.db.char.priority.fHeight / 10)
		self.PriorityFrame.axisgcd:SetPoint("BOTTOMRIGHT", self.PriorityFrame, "BOTTOMRIGHT",-Watcher.db.char.priority.IconSize, 0)
		end
		if self.db.char.growdir == "down" then
		self.PriorityFrame.axisgcd:SetWidth(Watcher.db.char.priority.IconSize)
		self.PriorityFrame.axisgcd:SetHeight(self.db.char.priority.fHeight / 10)
		self.PriorityFrame.axisgcd:SetPoint("TOPRIGHT", self.PriorityFrame, "TOPRIGHT",0, -Watcher.db.char.priority.IconSize)
		end
		if self.db.char.growdir == "up" then
		self.PriorityFrame.axisgcd:SetWidth(Watcher.db.char.priority.IconSize)
		self.PriorityFrame.axisgcd:SetHeight(self.db.char.priority.fHeight / 10)
		self.PriorityFrame.axisgcd:SetPoint("BOTTOMLEFT", self.PriorityFrame, "BOTTOMLEFT",0, Watcher.db.char.priority.IconSize)
		end
		self.PriorityFrame.axisgcd:SetTexture(0, 0, 0, 1)
		self.PriorityFrame.axisgcd:Show()
		self:AxisText()
		if (self.db.char.showaxis) then
			self.PriorityFrame.axisbase:SetAlpha(1)
		else
			self.PriorityFrame.axisbase:SetAlpha(0)
		end
	end

	function Watcher:SetPriorityFrame(FrameName, optionnum)
		FrameName:ClearAllPoints()
		FrameName:SetFrameStrata("BACKGROUND")
		if optionnum > 1 and self.db.char.priority.keybindings[optionnum - 1] ~=  nil then
		
		SetBindingSpell(self.db.char.priority.keybindings[optionnum - 1], Watcher.priorityTable.name[self.db.char.priority.option[optionnum]].."()")
		end
		FrameName:SetWidth(Watcher.db.char.priority.IconSize)
		FrameName:SetHeight(self.db.char.priority.IconSize)
		--FrameName:SetAlpha(1)
		FrameName:EnableMouse(0)
		if self.db.char.priority.option[optionnum] == "none" then
			FrameName:SetAlpha(0)
			Watcher.timeLeft[optionnum + 8] = -1
			Watcher.timeLeft[optionnum] = -1
		end
		--
		if optionnum == 1 then
			if not FrameName.texture then
				FrameName.texture = FrameName:CreateTexture(nil, "OVERLAY")
			end
			FrameName.texture:ClearAllPoints()
			FrameName.texture:SetWidth(self.db.char.priority.fHeight / 10)
			FrameName.texture:SetHeight(self.db.char.priority.fHeight / 10)
			if self.db.char.growdir == "right" then
			FrameName.texture:SetPoint("TOPRIGHT", FrameName, "BOTTOMRIGHT", 0, 0)
			elseif self.db.char.growdir == "up"  then
			FrameName.texture:SetPoint("TOPLEFT", FrameName, "TOPRIGHT", 0, 0)
			elseif self.db.char.growdir == "left" then
			FrameName.texture:SetPoint("TOPLEFT", FrameName, "BOTTOMLEFT", 0, 0)	
			elseif self.db.char.growdir == "down" then
			FrameName.texture:SetPoint("BOTTOMLEFT", FrameName, "BOTTOMRIGHT", 0, 0)
			end
			FrameName.texture:SetTexture(0,0,0,1)
		else
		--FrameName:RegisterForClicks("Any")
		if not FrameName.texture then
			FrameName.texture = FrameName:CreateTexture(nil, "OVERLAY")
		end
			FrameName.texture:SetWidth(Watcher.db.char.priority.IconSize)
			FrameName.texture:SetHeight(self.db.char.priority.IconSize)
			FrameName.texture:SetPoint("CENTER", FrameName, "CENTER", 0, 0)
			FrameName.texture:SetTexture(Watcher.priorityTable.icon[self.db.char.priority.option[optionnum]])
			--FrameName.texture:SetAlpha(1)
		--[[if not FrameName.ntexture then
			FrameName.ntexture = FrameName:CreateTexture(nil)
		end]]
		if LBF then
			if not FrameName.ntexture then
			FrameName.ntexture = FrameName:CreateTexture(nil)
			end
			local group = LBF:Group("Watcher","Watcher1")
			group:AddButton(FrameName, {Icon = FrameName.texture, Normal = FrameName.ntexture})
		end
		end
		FrameName:SetFrameLevel(90 - ((optionnum-1)*10))
		--if optionnum == 1 then FrameName:SetFrameLevel(1) end
		--if self.db.char.priority.keybindings[optionnum - 1] then	
			if not FrameName.keybind then
				FrameName.keybind = FrameName:CreateFontString(nil, "OVERLAY")
				
			end
			FrameName.keybind:Show()
			FrameName.keybind:ClearAllPoints()
			FrameName.keybind:SetTextColor(self.db.char.priority.keycol.r, self.db.char.priority.keycol.g, self.db.char.priority.keycol.b, self.db.char.priority.keycol.a)
			FrameName.keybind:SetFont(media:Fetch("font", self.db.char.iconfont), self.db.char.iconfontsize, self.db.char.iconfonteffect)
			FrameName.keybind:SetPoint("CENTER", FrameName, "CENTER", self.db.char.priority.keyhori, self.db.char.priority.keyvert)
			if self.db.char.priority.keybindings[optionnum-1] == "BUTTON4" then
				FrameName.keybind:SetText("B4")
			elseif self.db.char.priority.keybindings[optionnum-1] == "BUTTON3" then
				FrameName.keybind:SetText("B3")
			elseif self.db.char.priority.keybindings[optionnum-1] == "BUTTON5" then
				FrameName.keybind:SetText("B5")
			else
			FrameName.keybind:SetText(self.db.char.priority.keybindings[optionnum-1])
			end
		--end
		if self.db.char.priority.showlabel then
			if not FrameName.Label then
				FrameName.Label = FrameName:CreateFontString(nil, "OVERLAY")
			end
			FrameName.Label:Show()
			FrameName.Label:ClearAllPoints()
			FrameName.Label:SetTextColor(self.db.char.priority.labelcol.r, self.db.char.priority.labelcol.g, self.db.char.priority.labelcol.b, self.db.char.priority.labelcol.a)
			FrameName.Label:SetFont(media:Fetch("font", self.db.char.iconfont), self.db.char.iconfontsize, self.db.char.iconfonteffect)
			FrameName.Label:SetPoint("CENTER", FrameName, "CENTER", self.db.char.priority.labelhori, self.db.char.priority.labelvert)
			FrameName.Label:SetText(self.db.char.priority.Label[optionnum-1])
		else
			if FrameName.Label then
			FrameName.Label:Hide()
			end
			end	

		if not FrameName.Text then
			FrameName.Text = FrameName:CreateFontString(nil, "OVERLAY")
		end
		FrameName.Text:ClearAllPoints()
		FrameName.Text:SetTextColor(1,1,1,1)
		FrameName.Text:SetFont(media:Fetch("font", self.db.char.iconfont), self.db.char.iconfontsize, self.db.char.iconfonteffect)
		if self.db.char.textpoint == "top" then
		FrameName.Text:SetPoint("TOP", FrameName, "TOP", 0, self.db.char.iconfontsize + 2)
		elseif self.db.char.textpoint == "bottom" then
		FrameName.Text:SetPoint("BOTTOM", FrameName, "BOTTOM", 0, -self.db.char.iconfontsize + 2)
		elseif self.db.char.textpoint == "center" then
		FrameName.Text:SetPoint("CENTER", FrameName, "CENTER", 0, 0)
		end
		if self.db.char.showbars then
		Watcher:SetBack(FrameName, optionnum)
		else
		if FrameName.status then
		FrameName.status:Hide()
		end
		end
		FrameName:SetScript("OnUpdate", 
			function()
					if self.db.char.priority.option[optionnum] ~= "none" and (self.combat or not self.db.char.showcombat) then
						Watcher.priorityTable.check[self.db.char.priority.option[optionnum]](FrameName, optionnum)
					end
			end	);		

		if self.db.char.priority.iconcd then
			FrameName.Text:Show()
		else
			FrameName.Text:Hide()
		end
	end


	function Watcher:SetBack(FrameName, num)
		if not FrameName.status then
			FrameName.status =  CreateFrame("Frame", "Watcher_PriorityFrameStatus", self.PriorityFrame)
			
		end
		FrameName.status:Show()
		FrameName.status:ClearAllPoints()
		FrameName.status:SetFrameStrata("BACKGROUND")
		FrameName.status:EnableMouse(0)
		FrameName.status:SetWidth(Watcher.db.char.priority.IconSize)
		FrameName.status:SetHeight(self.db.char.priority.IconSize)
		FrameName.status:SetFrameLevel(10-num)
		FrameName.status:SetBackdropColor(0,0,0,0)
		if not FrameName.statusbar then
			FrameName.statusbar =  FrameName.status:CreateTexture(nil, "BACKGROUND")
		end
		FrameName.statusbar:Show()
		FrameName.statusbar:ClearAllPoints()
		FrameName.statusbar:SetWidth(self.db.char.priority.IconSize)
		FrameName.statusbar:SetHeight(self.db.char.priority.IconSize)
		--FrameName.statusbar:SetTexture(media:Fetch("statusbar", self.db.char.bartexture))
		local Number = num - 1
		if Number == 1 then
		FrameName.statusbar:SetTexture(self.db.char.barcol.bar1.r, self.db.char.barcol.bar1.g, self.db.char.barcol.bar1.b, self.db.char.barcol.bar1.a)
		elseif Number == 2 then
		FrameName.statusbar:SetTexture(self.db.char.barcol.bar2.r, self.db.char.barcol.bar2.g, self.db.char.barcol.bar2.b, self.db.char.barcol.bar2.a)
		elseif Number == 3 then
		FrameName.statusbar:SetTexture(self.db.char.barcol.bar3.r, self.db.char.barcol.bar3.g, self.db.char.barcol.bar3.b, self.db.char.barcol.bar3.a)
		elseif Number == 4 then
		FrameName.statusbar:SetTexture(self.db.char.barcol.bar4.r, self.db.char.barcol.bar4.g, self.db.char.barcol.bar4.b, self.db.char.barcol.bar4.a)
		elseif Number == 5 then
		FrameName.statusbar:SetTexture(self.db.char.barcol.bar5.r, self.db.char.barcol.bar5.g, self.db.char.barcol.bar5.b, self.db.char.barcol.bar5.a)
		elseif Number == 6 then
		FrameName.statusbar:SetTexture(self.db.char.barcol.bar6.r, self.db.char.barcol.bar6.g, self.db.char.barcol.bar6.b, self.db.char.barcol.bar6.a)
		elseif Number == 7 then
		FrameName.statusbar:SetTexture(self.db.char.barcol.bar7.r, self.db.char.barcol.bar7.g, self.db.char.barcol.bar7.b, self.db.char.barcol.bar7.a)
		elseif Number == 8 then
		FrameName.statusbar:SetTexture(self.db.char.barcol.bar8.r, self.db.char.barcol.bar8.g, self.db.char.barcol.bar8.b, self.db.char.barcol.bar8.a)
		end
		FrameName.statusbar:SetAlpha(0)
		--FrameName.statusbar:SetStatusBarColor(0, 1, 1, 0.8)
		if self.db.char.growdir == "left" then
		FrameName.statusbar:SetPoint("BOTTOMRIGHT", self.PriorityFrame, "BOTTOMRIGHT", -Watcher.db.char.priority.IconSize, 0)
		elseif self.db.char.growdir == "right" then
		FrameName.statusbar:SetPoint("BOTTOMLEFT", self.PriorityFrame, "BOTTOMLEFT", Watcher.db.char.priority.IconSize, 0)
		elseif self.db.char.growdir == "up" then
		FrameName.statusbar:SetPoint("BOTTOMRIGHT", self.PriorityFrame, "BOTTOMRIGHT", 0, Watcher.db.char.priority.IconSize)
		elseif self.db.char.growdir == "down" then
		FrameName.statusbar:SetPoint("TOPRIGHT", self.PriorityFrame, "TOPRIGHT", 0, -Watcher.db.char.priority.IconSize)
		end
		end
		
	function Watcher:ResetPriority()
		self.PriorityFrame:ClearAllPoints()
		self.db.char.point = self.defaults.char.point
		self.db.char.relativeTo = self.defaults.char.relativeTo 
		self.db.char.relativePoint = self.defaults.char.relativePoint
		self.db.char.xOffset = self.defaults.char.xOffset
		self.db.char.priority.yOffset = self.defaults.char.priority.yOffset
		Watcher.db.char.priority.fWidth = self.defaults.char.priority.fWidth
		self.db.char.priority.fHeight = self.defaults.char.priority.fHeight
		self.db.char.scale = self.defaults.char.priority.scale
		self.db.char.priority.option1 = { "gcd", "none", "none", "none", "none", "none", "none", "none", "none"}
		self.db.char.priority.option2 = { "gcd", "none", "none", "none", "none", "none", "none", "none", "none"}
		self:SwitchTalents()
		self.PriorityFrame:SetPoint(self.db.char.priority.point, self.db.char.priority.relativeTo, self.db.char.priority.relativePoint, self.db.char.priority.xOffset, self.db.char.priority.yOffset)
		self:CreatePriorityFrame()
		self:Print(L["priority_reset"])
	end

	function Watcher:expires(expiresin, dotthreshold, typedot, typeShortDot, buffproc, count, countreq)
		--self:Print(count.. " ".. countreq.." "..expiresin.." " .. dotthreshold)
		if buffproc then
			return false
		elseif count < countreq  and expiresin > dotthreshold then
			return true	
		elseif typeShortDot and expiresin > dotthreshold then
			return true
		elseif typedot and expiresin > dotthreshold then
			return true
		end
			return false
	end

	function Watcher:countcheck(count, countreq, timeleft, buffproc)

		if countreq == 0 or countreq == 1 then
			return true
		elseif count < countreq  and not buffproc or timeleft > 0 then
			return true
		elseif count >= countreq or timeleft > 0 then
			return true
		end
		return false
	end

	function Watcher:Power(power, powerthreshold)
	return power > powerthreshold
	end
	
	--[[function Watcher:UpdateSpell(FrameName, optionnum, typedot, dotfunction, typeShortDot, shortDotTime, usehealthpc, SpellName, powerthreshold, countreq, dotthreshold, combocost, isproc, findcount) 
			--FrameName:Show()
			local usable = IsUsableSpell(SpellName)
			--FrameName:SetAlpha(1)
			local expiresin
			local Count = 0
			local power = UnitPower("player")
			local maxpower = UnitPowerMax("player")
			power = power/maxpower
			powerthreshold = powerthreshold / 100
			local combo = GetComboPoints("player", "target")
			if combocost == nil then combocost = 0 end
			local buffproc = false
			local typeaura = false
			if typedot and isproc then
				expiresin, Count = dotfunction
				buffproc = true
				if Count == nil then Count = findcount or 0 end
			elseif typedot and not typeShortDot then
				expiresin, Count = dotfunction
				if Count == nil then Count = findcount or 0 end
				if expiresin == true then
				typeaura = true
				end
			elseif typeShortDot and not typedot then
				expiresin = shortDotTime - GetTime()
				Count = 0
			elseif typedot and typeShortDot then 
				expiresin, Count = dotfunction
				buffproc = true
			elseif typedot and isproc then
				expiresin, Count = dotfunction
				buffproc = true
			else
				expiresin = 0
				Count = 0
			end
			local start, duration = GetSpellCooldown(SpellName)
			if start == nil then
			start = 0
			duration = 0
			end
			local timeleft = start + duration - GetTime()
			if Watcher:bossmob(optionnum) then
				if buffproc == false or expiresin > 0 then	
					if Watcher:countcheck(Count, countreq, timeleft, buffproc) then
					if power >= powerthreshold then
						if not typeaura then
							if combo >= combocost then
								if Watcher:expires(expiresin, dotthreshold, typedot, typeShortDot, buffproc, Count, countreq) or timeleft > 0 then
									if timeleft < expiresin and not buffproc then
										timeleft = expiresin
										usable = 1
									end
									
									Watcher.timeLeft[optionnum] = timeleft
									Watcher.timeLeft[optionnum + 8] = timeleft
									if timeleft <= dotthreshold then 
										timeleft = 0 
									else 
										timeleft = timeleft - dotthreshold 
									end
									if usable == 1 then
										Watcher.timeLeft[optionnum + 8] = -1
										FrameName:SetAlpha(1)
										Watcher:MoveIcon(FrameName, timeleft, optionnum)
									else 
										Watcher.timeLeft[optionnum] = -1
										FrameName:SetAlpha(0.3)
										Watcher:MoveIcon(FrameName, timeleft, optionnum + 8)
									end
									if Watcher.db.char.priority.textshow then
										FrameName.Text:SetText(Watcher:DurationString(timeleft))
										FrameName.Text:Show()
									else
									
										FrameName.Text:Hide()
									end
									if timeleft > Watcher.db.char.priority.maxtime then
										FrameName:SetAlpha(0)
									else
									
										FrameName:SetAlpha(1)
									end
									return
								end -- Expires
							
								FrameName.Text:Hide()
								if usable == 1 then
									Watcher.timeLeft[optionnum] = 0
									Watcher.timeLeft[optionnum + 8] = -1
									Watcher:MoveIcon(FrameName, 0, optionnum)
								else 
									Watcher.timeLeft[optionnum] = -1
									FrameName:SetAlpha(0.3)
									Watcher.timeLeft[optionnum + 8] = 0
									Watcher:MoveIcon(FrameName, 0, optionnum + 8)
								end
								return
							end -- combo
						end -- typeaura
					end -- power
				end -- countcheck
			end -- buffproc
			end 
			FrameName:SetAlpha(0.3)
			if self.db.char.showbars then
				FrameName.statusbar:SetAlpha(0)
			end
			Watcher.timeLeft[optionnum] = -1
			Watcher.timeLeft[optionnum + 8] = -1-- boss
	end]]
	
	function Watcher:UpdateSpell(FrameName, optionnum, typedot, dotfunction, typeShortDot, shortDotTime, usehealthpc, SpellName, powerthreshold, countreq, dotthreshold, combocost, isproc, findcount) 
			FrameName:Show()
			local usable = IsUsableSpell(SpellName)
			FrameName:SetAlpha(1)
			local expiresin
			local Count = 0
			local power = UnitPower("player")
			local maxpower = UnitPowerMax("player")
			power = power/maxpower
			powerthreshold = powerthreshold / 100
			local combo = GetComboPoints("player", "target")
			if combocost == nil then combocost = 0 end
			local buffproc = false
			local typeaura = false
			if typedot and isproc then
				expiresin, Count = dotfunction
				buffproc = true
				if Count == nil then Count = findcount or 0 end
			elseif typedot and not typeShortDot then
				expiresin, Count = dotfunction
				if Count == nil then Count = findcount or 0 end
				if expiresin == true then
				typeaura = true
				end
			elseif typeShortDot and not typedot then
				expiresin = shortDotTime - GetTime()
				Count = 0
			elseif typedot and typeShortDot then 
				expiresin, Count = dotfunction
				buffproc = true
			elseif typedot and isproc then
				expiresin, Count = dotfunction
				buffproc = true
			else
				expiresin = 0
				Count = 0
			end
			local start, duration = GetSpellCooldown(SpellName)
			if start == nil then
			start = 0
			duration = 0
			end
			local timeleft = start + duration - GetTime()
			if Watcher:bossmob(optionnum) then
				if buffproc == false or expiresin > 0 then	
					if Watcher:countcheck(Count, countreq, timeleft, buffproc) then
					if Watcher:Power(power, powerthreshold, SpellName) then
						
						if not typeaura then
							if combo >= combocost then
								if Watcher:expires(expiresin, dotthreshold, typedot, typeShortDot, buffproc, Count, countreq) or timeleft > 0 then
									if timeleft < expiresin and not buffproc then
										timeleft = expiresin
										usable = 1
									end
								--	if usable == 1 then
										Watcher.timeLeft[optionnum] = timeleft
										Watcher.timeLeft[optionnum+8] = timeleft
										if timeleft <= dotthreshold then timeleft = 0 
										else timeleft = timeleft - dotthreshold end
										if usable == 1 then
											Watcher.timeLeft[optionnum+8] = -1
											Watcher:MoveIcon(FrameName, timeleft, optionnum)
											FrameName:SetAlpha(1)
										else 
											Watcher.timeLeft[optionnum] = -1
											Watcher:MoveIcon(FrameName, timeleft, optionnum+8)
											FrameName:SetAlpha(0.3)
										end
										if Watcher.db.char.priority.textshow then
											FrameName.Text:SetText(Watcher:DurationString(timeleft))
											FrameName.Text:Show()
										else
											FrameName.Text:Hide()
										end
										if timeleft > Watcher.db.char.priority.maxtime then
											FrameName:SetAlpha(0)
										end
										return
								--	end-- USABLE
								end -- Expires
							--end
						--	if usable == 1 then
								FrameName.Text:Hide()
								if usable == 1 then
										Watcher.timeLeft[optionnum] = 0
										Watcher.timeLeft[optionnum+8] = -1
										Watcher:MoveIcon(FrameName, 0, optionnum)
										FrameName:SetAlpha(1)
								else 
										Watcher.timeLeft[optionnum] = -1
										Watcher.timeLeft[optionnum+8] = 0
										Watcher:MoveIcon(FrameName, 0, optionnum+8)
										FrameName:SetAlpha(0.3)
								end
								return
						--	end -- USABLE
					end -- combo
					end -- typeaura
				end -- typeaura
				end -- power
			end -- buffproc
		end 
		FrameName:SetAlpha(0)
		if self.db.char.showbars then
			FrameName.statusbar:SetAlpha(0)
		end
		Watcher.timeLeft[optionnum] = -1-- boss
	end